Subject: Re: MIDX woes, was Re: [ANNOUNCE] Git v2.54.0-rc2

From: Junio C Hamano <[email-masked]>
Date: Thu, 16 Apr 2026 09:09:10 -0700

Derrick Stolee <[email-masked]> writes:

>> I think doing so is just this one-liner:
> ...
>> and then here we need to use v2 for the new compaction feature:
> ...
> I think this is a good change to make. This fits with the standard
> approach of not making breaking file changes by default, but letting
> users opt-in to new versions (at least for a few major releases).

Yes.

Is anybody volunteering to put the patches together?

> The part that is striking about Johannes' report is that this happens
> on a fetch, so it is being written automatically by normal maintenance
> activities in that case. Without downgrading the default version back
> to a compatible version, deleting the multi-pack-index(es) will not
> keep the repo in a good state.

I am not sure what you mean by "deleting will not keep the
repository in a good state".  Isn't multi-pack-index totall
optional?

> As for the multi-pack-index being optional, I agree that we _could_
> have a more graceful fallback to the pack-indexes when we don't
> recognize the file format version. This should still be a very visible
> warning as it can be an important performance feature, so users should
> be notified when it isn't working as they expect. (This can be done
> separately from this late-in-rc change for the default version.)

True.

Thanks.